<div class="runs-filter">
    <div class="runs-filter__controls"
        blur-filter
        blur-radius="1px"
        blur-active="{{$ctrl.isBlurActive}}">
        <div class="runs-filter__control-wrapper">
            <!--TODO: add clear (x) button-->
            <md-input-container class="runs-filter__control-item runs-filter__search _small _with-icon _without-animation">
                <label class="runs-filter__search-label placeholder-label">Search items</label>
                <input type="text"
                    class="runs-filter__search-input"
                    ng-model="$ctrl.searchParams.query"
                    ng-model-options="{debounce: $ctrl.debounceDelay}"
                    ng-change="$ctrl.onChangeSearchCriteria()"
                    aria-label="Search items"
                    aria-describedby="basic-addon2">
                <i class="runs-filter__search-icon material-icons">
                    search
                </i>
            </md-input-container>
        </div>
        <div class="runs-filter__control-wrapper"
            ng-repeat="visibleSearchControl in $ctrl.visibleSearchControls track by visibleSearchControl.id"
            ng-class="{ _active: $ctrl.isControlActive(visibleSearchControl) }">
            <md-button class="md-icon-button _default-md-style"
                ng-if="!visibleSearchControl.isDefault"
                ng-click="$ctrl.hideControl(visibleSearchControl)">
                <md-icon aria-label="remove control">close</md-icon>
            </md-button>
            <md-input-container class="runs-filter__control-item _select select-wrapper without-animation"
                ng-if="visibleSearchControl.type === 'select'">
                <md-select ng-attr-id="{{visibleSearchControl.id}}"
                    ng-attr-name="{{visibleSearchControl.key}}"
                    ng-attr-placeholder="{{visibleSearchControl.label}}"
                    ng-class="{ '_with-close-btn': !visibleSearchControl.isDefault }"
                    ng-model="$ctrl.searchParams[visibleSearchControl.key]"
                    class="runs-filter__control-select _small"
                    md-selected-html="$ctrl.getSelectControlText(visibleSearchControl)"
                    md-on-close="$ctrl.onChangeSearchCriteria()"
                    multiple>
                    <md-option ng-repeat="optionValue in visibleSearchControl.options"
                        ng-value="::optionValue">{{ optionValue }}</md-option>
                    <div class="runs-filter__control-select-clear"
                        ng-click="$ctrl.clearControl(visibleSearchControl)">Clear</div>
                </md-select>
            </md-input-container>
            <md-input-container class="runs-filter__control-item _date"
                ng-class="{ _active: $ctrl.isDateSearchActive}"
                ng-if="visibleSearchControl.type === 'datePicker'">
                <md-button ng-attr-id="{{visibleSearchControl.id}}"
                    class="_small _right-icon"
                    ng-click="$ctrl.showDatePickerDialog($event, true)">
                    <span class="md-button__text"
                        ng-if="$ctrl.selectedRange.selectedTemplateName">
                        {{visibleSearchControl.label}}: <strong>{{$ctrl.selectedRange.selectedTemplateName}}</strong>
                    </span>
                    <span class="md-button__text"
                        ng-if="!$ctrl.selectedRange.selectedTemplateName">
                        {{visibleSearchControl.label}}
                    </span>
                    <i class="material-icons">date_range</i>
                </md-button>
            </md-input-container>
            <md-input-container class="runs-filter__control-item _button"
                ng-class="{ _active: $ctrl.searchParams[visibleSearchControl.key]}"
                ng-if="visibleSearchControl.type === 'button'">
                <md-button class="_small"
                    ng-click="visibleSearchControl.onClick()">
                    {{visibleSearchControl.label}}
                </md-button>
            </md-input-container>

        </div>
    </div>
    <div class="runs-filter__actions"
        blur-filter
        blur-radius="1px"
        blur-active="{{$ctrl.isBlurActive}}">
        <div class="runs-filter__action-item">
            <md-menu md-offset="30 20" class="runs-filter__control-item runs-filter__more-menu">
                <md-button class="runs-filter__action-button runs-filter__more-button _left-icon _small"
                    aria-label="Add more controls"
                    ng-click="$mdMenu.open($event)"><md-icon>add</md-icon>More</md-button>
                <md-menu-content class="runs-filter__more-menu-content">
                    <md-menu-item class="runs-filter__more-menu-item"
                        ng-repeat="hidingSearchControl in $ctrl.hidingSearchControls track by hidingSearchControl.id">
                        <md-checkbox ng-model="hidingSearchControl.isVisible"
                            class="runs-filter__more-menu-checkbox"
                            aria-label="Disabled control">
                            {{hidingSearchControl.label}}
                        </md-checkbox>
                    </md-menu-item>
                    <md-menu-item class="runs-filter__more-menu-item _separated">
                        <md-button ng-click="$ctrl.clearAllControls()"
                            class="runs-filter__more-menu-close"
                            aria-label="Close menu">Clear</md-button>
                    </md-menu-item>
                </md-menu-content>
            </md-menu>
        </div>
        <div class="runs-filter__action-item _reset">
            <md-button ng-if="$ctrl.isSearchActive"
                class="md-raised _small"
                ng-click="$ctrl.resetSearch();">RESET</md-button>
        </div>
        <div class="runs-filter__action-item _save">
            <md-button ng-if="$ctrl.isSearchActive"
                class="md-raised md-primary _small"
                ng-click="$ctrl.onSearchSave();">SAVE</md-button>
        </div>
        <div class="runs-filter__action-item _saves">
            <button class="runs-filter__active-filter"
                ng-repeat="activeSearch in $ctrl.searchesList | filter:{isActive:true}"
                ng-click="$ctrl.resetSearch()">
                {{activeSearch.name}}
            </button>
            <a class="runs-filter__action-link" href="#" ng-click="$ctrl.toggleSavedSearchesSidenav()">Show all saved filters</a>
        </div>
    </div>
    <ng-transclude></ng-transclude>
</div>
